/***************************************************************************
 *   Copyright (C) 2006-2007 by Ricardo I. Vieitez - Fernando Beradi       *
 *   ricardo@mundolinux.org - fernando@zerial.org                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation (version 2 of the License)               *
 *                                                                         *
 *   Note that the only valid version of the GPL as far as this server is  *
 *   the version 2 of the license but not any other (i.e. v2, not 1 or 2.2 *
 *   or 3 or whatever), unless explicitly otherwise stated.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.           *
 ***************************************************************************/

#ifndef USER__SERVER_H
#define FATAL_ERROR_PAGE "HTTP/1.0 500 Internal Server Error\n\
Server: Pinguino Web Server\n\
Content-type: text/html\n\n\
<html><head><title>Pinguino WS</title></head><body><b>Pinguino Web Server. No configuration available  yet</b></body></html>\n"

#define PINGUINO_WEB "http://www.pinguinows.org/"
#define PINGUINO_VERSION "0.1a1"

enum servErr_t {
	SOCKET=1,
	BIND=2,
	LISTEN=4,
	REQUESTS=8
};

enum paramErr_t {
	OK=0,
	BAD_PORT=1,
	UNSET_PORT=2,
	BAD_ROOT=4,
	UNSET_ROOT=8
};

typedef enum servErr_t servErr;
typedef enum paramErr_t paramErr;

struct c_ws_config {
	int port;
	char *root;
};

/* Main server class */
/* c_WebServer */
class c_WebServer {
	/* Variables declaration */
	private:
		int m_iPort; /* Web server port */
	protected:
		int m_iSockfd, m_iNewfd; /* Socket */
		int m_iSinSize; /* Socket size */
		char *m_psRoot;
		struct sockaddr_in *m_pServAddr; /* Server Address */
		struct sockaddr_in *m_pClientAddr; /* Client address */
		
	/* Functions declaration */
	private:
		char* FatalErrorPage(void);
	public:
		c_WebServer(); /* Standard constructor */
		c_WebServer(int PORT); /* Constructor */
		
		paramErr setPort(int); /* Set server port */
		paramErr setRoot(char[]); /* Set server root */
		paramErr operator= (c_ws_config&); /* Load server config */

		int whatPort(void); /* Server port */
		char* whatRoot(void); /* Server root */
		
		servErr listen(); /* Start listening */
		servErr operator++ (); /* Start listening */
		
		void newRequest(void); /* Process a new request */
		void operator~(void); /* Process a new request */
};
#define USER__SERVER_H
#endif
